#version 430 core
//shader for lamp's depth cubemap
in vec4 fPosition;
in vec2 fTextCoords;

uniform vec3 lightPosition;
uniform float farPlane; //light's far plane
uniform sampler2D fragTexture;

void main()
{
	
	if((texture(fragTexture, fTextCoords)).a < 0.15) //discard semi-transparent parts (for tree leaves)
	discard;

    float zValue = length(fPosition.xyz - lightPosition); //calculate depth value as distance to light
    
    zValue = zValue / farPlane; //bring to [0,1] range    
   
    gl_FragDepth = zValue;	
}