#version 430 core
//shader for lamp's depth cubemap
layout (triangles) in;
layout (triangle_strip, max_vertices=18) out; //3*6

in vertexData {
	vec2 textCoords;
} inputData[];

uniform mat4 lampVpMatrices[5]; //lamp's view projection matrices for each cube side except top

out vec4 fPosition; // FragPos from GS (output per emitvertex)
out vec2 fTextCoords;

void main()
{
	int j = 0;
    for(int side = 0; side < 6; ++side) //for each side of cube
    {
		
		if(side!=2) //don't render top of cubemap (completely in shadow because of lamp's form)
		{
			
			gl_Layer = side; //specify side of cubemap
			
			for(int i = 0; i < 3; ++i) // for each triangle's vertices
			{
				fTextCoords = inputData[i].textCoords;
				fPosition = gl_in[i].gl_Position;
				gl_Position = lampVpMatrices[j] * fPosition;
			
				EmitVertex();
			} 
			++j;
			EndPrimitive();			
		}
		
    }
} 