#version 430 core
layout (triangles) in;
layout (triangle_strip, max_vertices=18) out; //3*6 (vertices per triangle * 6 sides of cube)

uniform mat4 viewDirectionMatrices[6]; //vp matrices for each cube side
uniform mat4 lightVpMatrix; //moonlight's vp matrix to transform to light space

in vertexData {
    vec3 position;
	vec3 normal;
	vec2 textCoords;	
} inputData[];

out vec3 fPosition;
out vec3 fNormal;
out vec2 fTextCoords;
out vec4 fPositionLightSpace;


void main()
{
	
	//for each cube side
    for(int side = 0; side < 6; ++side)
    {
        gl_Layer = side; //specify to which side it is rendered, each layer contains 1 side of cubemap
        for(int i = 0; i < 3; ++i) //for each vertex of triangle
        {            
			fPosition = inputData[i].position;			
			fNormal = inputData[i].normal;
			fTextCoords = inputData[i].textCoords;
			fPositionLightSpace = lightVpMatrix * gl_in[i].gl_Position;			
			gl_Position = viewDirectionMatrices[side] * gl_in[i].gl_Position;            
            EmitVertex();
        }    
        EndPrimitive();
    }
}