#version 430 core
layout (location = 0) in vec3 positions;
layout (location = 1) in vec3 normals;
layout (location = 2) in vec2 vTextCoords;

out vertexData {
    vec3 position;
	vec3 normal;
	vec2 textCoords;	
} outputData;

uniform mat4 model;
uniform mat4 modelInv; //inverse model matrix


void main()
{	
	outputData.position = vec3(model * vec4(positions, 1.0)); //position in world space for light calculations
	mat3 normalMatrix = mat3(transpose(modelInv));
	outputData.normal = normalMatrix * normals; //so normals stay perpendicular when scaled	
	outputData.textCoords = vTextCoords;
	
	gl_Position = model * vec4(positions, 1.0);
}