#version 430 core
out vec4 FragColor;

in vec3 fNormals;
in vec3 fPositions;

uniform vec3 cameraPosition;
uniform samplerCube environmentMap;
uniform float time;

void main()
{    
	//reflection: R = V - 2 * (N dot V) * N
	//V... angle of incidence, N... normal vector, both normalized
	
	vec3 V = normalize(fPositions - cameraPosition);
	vec3 N;
	if(time > 135)	//when sphere starts to grow
		N = fNormals; //don't normalize normals for "warp" effect
	else
		N = normalize(fNormals);	

	vec3 R = V - 2 * (dot(N,V)) * N; //with formula
    
    //vec3 R = reflect(V, N); //with built-in function
	
	FragColor = vec4(texture(environmentMap, R).rgb, 1.0);
}