#version 430 core
layout (location = 0) in vec3 positions;
layout (location = 1) in vec3 normals;

out vec3 fNormals;
out vec3 fPositions;

uniform mat4 model;
uniform mat4 modelInv; //inverse model matrix
uniform mat4 vp; //projection * view

void main()
{
	mat3 normalMatrix = mat3(transpose(modelInv));	
	fNormals = normalMatrix * normals; //so normals stay perpendicular when scaled	
    fPositions = vec3(model * vec4(positions, 1.0)); //in world space for view direction calc	
	gl_Position = vp * model * vec4(positions, 1.0);	
}